/*
 * gamelib.h: ɮxCclassinterface
 * Copyright (C) 2002 Woei-Kae Chen <wkc@csie.ntut.edu.tw>
 *
 * This file is part of game, a free game development platform for windows.
 *
 * game is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * game is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#define DDRAW_MAX_BITMAPS	100		// CiΨ̦hϧμ
#define AUDIO_MAX_SOUNDS	100		// CiΨ̦hn
#define AUDIO_ENABLE		true	// ҰʭĤ

/////////////////////////////////////////////////////////////////////////////
// oclassѰʺA(iH)ϧ
// CPublic InterfaceΪknAImplementationiH
/////////////////////////////////////////////////////////////////////////////

class CMovingBitmap {
public:
	CRect GetLocation();				// oϧΦbùWy
	int   Height();						// oϧΪ
	int   Left();						// oϧΪW x y
	void  LoadBitmap(int,int,int,COLORREF=CLR_INVALID);
										// ]wϪȡGϪsByСBγz
	void  SetTopLeft(int,int);			// NϪWyв (x,y)
	void  ShowBitmap();					// N϶K Back Plain
	void  ShowBitmap(CMovingBitmap &);	// N϶Kt@iϤW
	int   Top();						// oϧΪW y y
	int   Width();						// oϧΪe
protected:
	int SurfaceID;
	CRect location;
};

/////////////////////////////////////////////////////////////////////////////
// oclassѮɶB~
// CPublic InterfaceΪknAImplementationiH
/////////////////////////////////////////////////////////////////////////////

class CSpecialEffect {
public:
	static void  SetCurrentTime();					// xsثeɶctime
	static DWORD GetEllipseTime();					// Ūثeɶ - ctime
	static int   GetCurrentTimeCount();				// Ūxsctime
	static void  Delay(DWORD ms);					//  x ms
	static void  DelayFromSetCurrentTime(DWORD ms);	// ctime_A x ms
	static void  Abort(char *s);					// oY~A{
private:
	static DWORD ctime;
	static int	 ctimeCount;
};

/////////////////////////////////////////////////////////////////////////////
// oclass|إDirectDrawAHѨLclassϥ
// CPublic InterfaceΪknAImplementationiH
/////////////////////////////////////////////////////////////////////////////

class CDDraw {
	friend class CMovingBitmap;
public:
	~CDDraw();
	static void  BltBackColor(DWORD);		// NBack plainۤWwC
	static void  BltBackToPrimary();		// NBack plainKPrimary plain
	static CDC*  GetBackCDC();				// oBack PlainDC (device context)
	static void  GetClientRect(CRect &r);	// o]wѪR
	static void  Init(int, int);			// Initialize direct draw
	static void  ReleaseBackCDC();			// Back PlainDC (device context)
	static bool  SetFullScreen(bool);		// ]wùҦ/Ҧ
private:
	CDDraw();								// private constructor
	static void  BltBitmapToBack(int SurfaceID, int x, int y);
	static void  BltBitmapToBitmap(int SourceID, int TargetID, int x, int y);
	static void	 CheckDDFail(char *s);
	static void	 CheckSystem(int,int);
	static bool  CreateSurface();
	static bool  CreateSurfaceFullScreen();
	static bool  CreateSurfaceWindowed();
	static void  LoadBitmap(int i, int IDB_BITMAP);
	static DWORD MatchColorKey(LPDIRECTDRAWSURFACE lpDDSurface, COLORREF color);
	static int   RegisterBitmap(int IDB_BITMAP, COLORREF ColorKey);
	static void  ReleaseSurface();
	static void  RestoreSurface();
	static void  SetColorKey(int SurfaceID, COLORREF color);
	static const int			MaxNumBitmaps;
    static HDC					hdc;
	static CDC					cdc;
	static CView				*pCView;
    static LPDIRECTDRAW2		lpDD;
	static LPDIRECTDRAWCLIPPER	lpClipperPrimary;   
	static LPDIRECTDRAWCLIPPER	lpClipperBack;   
	static LPDIRECTDRAWSURFACE	lpDDSPrimary;
	static LPDIRECTDRAWSURFACE	lpDDSBack;
	static LPDIRECTDRAWSURFACE	*lpDDS;
    static HRESULT				ddrval;
	static int					*BitmapID;
	static CRect				*BitmapRect;
	static COLORREF				*BitmapColorKey;
	static bool					fullscreen;
	static CDDraw				ddraw;
	static int					size_x, size_y;
};

/////////////////////////////////////////////////////////////////////////////
// oclass|إDirectX AudioAHѭ
// CPublic InterfaceΪknAImplementationiH
// `NƶGɮץiHWAVE(.wav)MIDI(.mid)AƭӭɮץiH
//           VX(P)AO䤤uVX@MIDIɡAMIDIɮפ
//           PɼApGPɼMIDIɪܡAe@MIDIɷ|Q
//           C
/////////////////////////////////////////////////////////////////////////////

class CAudio {
public:
	~CAudio();
	void           Close();					// Direct Sound
	static CAudio *Instance();				// oCAudioInstance
	bool           Load(int, char *);		// JsinAwMIDIɮ
	bool           Open();					// }Direct Sound
	void           Play(int, bool=false);	// }lsinAwO_м
	void           Stop(int);				// sin
private:
	CAudio();						// private constructor
	static CAudio					audio;
	IDirectMusicLoader8				*g_pLoader;
	IDirectMusicPerformance8		*g_pPerformance;
	IDirectMusicSegment8			*g_pSegment[AUDIO_MAX_SOUNDS];
	bool							isMIDI[AUDIO_MAX_SOUNDS];
};
