/*
 * mygame.h: ɮxCclassinterface
 * Copyright (C) 2002 Woei-Kae Chen <wkc@csie.ntut.edu.tw>
 *
 * This file is part of game, a free game development platform for windows.
 *
 * game is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * game is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <list>
using namespace std;

/////////////////////////////////////////////////////////////////////////////
// Constants
/////////////////////////////////////////////////////////////////////////////

#define SIZE_X		640		// ]wCeѪR׬640x480
#define SIZE_Y		480		// (YϥμзǪѪRסAhù)

enum AUDIO_ID {				// wqUحĪs
	AUDIO_DING,				// 0
	AUDIO_CHORD,			// 1
	AUDIO_LAKE,				// 2
	AUDIO_CANYON			// 3
};

/////////////////////////////////////////////////////////////////////////////
// oclassѥiHʪʵe
// CPublic InterfaceΪknAImplementationiH
/////////////////////////////////////////////////////////////////////////////

class CAnimation {
public:
	CAnimation(int=10);				// Constructor (w]WvC1/3@i)
	void  AddBitmap(int,int,int,COLORREF=CLR_INVALID);
									// W[@iϧΦܰʵe(ϪsByСBγz)
	CRect GetLocation();			// oʵebùWy
	int   Height();					// oʵe
	int   Left();					// oʵeW x y
	void  SetTopLeft(int,int);		// NʵeWyв (x,y)
	void  ShowBitmap();				// NʵeK Back Plain
	int   Top();					// oʵeW y y
	int   Width();					// oʵee
private:
	list<CMovingBitmap>				bmp;			// list of CMovingBitmap
	list<CMovingBitmap>::iterator	bmp_iter;		// list iterator
	int								delay_counter;	// pƾ(wʵet)
	const int						DELAY_COUNT;	// ]wʵetת`
	int								x, y;			// ʵey
};

/////////////////////////////////////////////////////////////////////////////
// oclassѥiHʪy
// CPublic InterfaceΪknAImplementationiH
/////////////////////////////////////////////////////////////////////////////

class CBall : public CMovingBitmap
{
public:
	CBall();
	void SetDiffX(int);				// ]wU@Ӯy x b첾q
	void SetDiffY(int);				// ]wU@Ӯy y b첾q
	int  GetDiffX();				// Ūثe x b첾q
	int  GetDiffY();				// Ūثe y b첾q
	void Move();					// NϪyвܤU@Ӯy
	void BounceX();					// N x b첾qt(ϼu)
	void BounceY();					// N x b첾qt(ϼu)
	bool NextMoveInRectX(CRect r);	// U@Ӯy(xb)O_Mbخr
	bool NextMoveInRectY(CRect r);	// U@Ӯy(yb)O_Mbخr
	bool NextMoveInRect(CRect r);	// U@ӮyЬO_Mbخ r 
	bool NextMoveHitRectX(CRect r);	// U@Ӯy(xb)O_|خ r 
	bool NextMoveHitRectY(CRect r);	// U@Ӯy(yb)O_|خ r
	bool NextMoveHitRect(CRect r);	// U@ӮyЬO_|خ r
protected:
	CPoint diff;
};

/////////////////////////////////////////////////////////////////////////////
// oclassOC֤ߡACi
// CInterfaceΪkΨImplementationn
/////////////////////////////////////////////////////////////////////////////

class CGame {
public:
	CGame();										// Constructor
	~CGame();										// Destructor
	bool IsRunning();								// ŪCO_bi椤
	void Move();									// ʹC
	void OnDraw();									// CGameViewOnDraw()
	void OnFileNew();								// }lsC
	void OnFilePause();								// CȰ
	void OnInitialUpdate();							// CȤιϧγ]w
	bool OnIdle();									// CDj
	void OnKillFocus();								// CQȰ
	void OnLButtonDown(UINT nFlags, CPoint point);	// Bzƹʧ@
	void OnLButtonUp(UINT nFlags, CPoint point);	// Bzƹʧ@
	void OnRButtonDown(UINT nFlags, CPoint point);	// Bzƹʧ@
	void OnRButtonUp(UINT nFlags, CPoint point);	// Bzƹʧ@
	void Show();									// ܹCe
private:
	const int     NUMBALLS;		// y`
	CAnimation	  animation;	// ʵe
	CMovingBitmap background;	// I
	CBall		  *ball;		// y}C
	CMovingBitmap corner;		// 
	CBall		  racket;		// l
	bool          running;		// CO_bi椤()
};
